> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/optimization/optimize.md).

# Optimize & compress PDFs using JavaScript

Learn how to optimize and compress PDF files using the latest image compression technology. Reduce file size and enhance performance with PDF optimization techniques. The Apryse Web SDK streamlines se

{% hint style="warning" %}
Make sure you have [Full API enabled in WebViewer.](/web/what-is-webviewer/full-api.md)
{% endhint %}

To optimize a PDF with default settings.

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
async function main() {
	const doc = await PDFNet.PDFDoc.createFromFilePath(filename);
	await PDFNet.Optimizer.optimize(doc);
}
PDFNet.runWithCleanup(main);
```

{% endcode %}
{% endtab %}
{% endtabs %}

[Compress & optimize PDF files](/web/get-started/samples.md#optimizer) Full code sample which shows how to use 'pdftron.PDF.Optimizer' to reduce PDF file size by removing redundant information and compressing data streams using the latest in image compression technology.

## About optimize and compress

Compression as a subset of optimization represents encoding specific data using fewer bits than the original content by reducing the size of the data. This is distinct from optimize (which modifies all images) because you have the ability to choose individual images and to selectively choose the compression type for each.

Apryse SDK supports all basic and advanced compression filters allowed in PDF including:

* JPEG2000
* JBIG2
* CCITT Fax
* Flate/PNG
* JPEG/DCT
* Crypt Filters

## Compress images in a PDF document

{% hint style="warning" %}
Make sure you have [Full API enabled in WebViewer.](/web/what-is-webviewer/full-api.md)
{% endhint %}

To compress images using JBIG2 compression inside a PDF.

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
async function main() {
	const pdf_doc = await PDFNet.PDFDoc.createFromURL(filename);
	pdf_doc.initSecurityHandler();

	const cos_doc = await pdf_doc.getSDFDoc();
	const num_objs = await cos_doc.xRefSize();
	for (let i = 1; i < num_objs; ++i) {
		const obj = await cos_doc.getObj(i);
		if (obj && !(await obj.isFree()) && await obj.isStream()) {
			// Process only images
			var itr = await obj.find("Subtype");
			if (!(await itr.hasNext()) || await (await itr.value()).getName() !== "Image")
				continue;
			const input_image = await PDFNet.Image.createFromObj(obj);
			// Process only gray-scale images
			if (await input_image.getComponentNum() != 1)
				continue;
			if (await input_image.getBitsPerComponent() != 1) // Recompress only 1 BPC images
				continue;

			// Skip images that are already compressed using JBIG2
			itr = await obj.find("Filter");
			if (await itr.hasNext()) {
				const value = await itr.value();
				if (await value.isName() && await value.getName() === "JBIG2Decode") continue;
			}

			const filter = await obj.getDecodedStream();
			const reader = await PDFNet.FilterReader.create(filter);

			const hint_set = await PDFNet.ObjSet.create();
			const hint = await hint_set.createArray();

			hint.pushBackName("JBIG2");
			hint.pushBackName("Lossless");

			const new_image = await PDFNet.Image.createFromStream(cos_doc, reader, await input_image.getImageWidth(),
				await input_image.getImageHeight(), 1, await PDFNet.ColorSpace.createDeviceGray(), hint);

			const new_img_obj = await new_image.getSDFObj();
			itr = await obj.find("Decode");
			if (await itr.hasNext())
				new_img_obj.put("Decode", await itr.value());
			itr = await obj.find("ImageMask");
			if (await itr.hasNext())
				new_img_obj.put("ImageMask", await itr.value());
			itr = await obj.find("Mask");
			if (await itr.hasNext())
				new_img_obj.put("Mask", await itr.value());

			await cos_doc.swap(i, await new_img_obj.getObjNum());
		}
	}
}
PDFNet.runWithCleanup(main);
```

{% endcode %}
{% endtab %}
{% endtabs %}

[PDF image JBIG2 compression](/web/get-started/samples.md#jbigtest) Full sample code which illustrates how to recompress bitonal (black and white) images in existing PDF documents using JBIG2 compression.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/web/optimization/optimize.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
